-- Copyright (c) 2004, Jim C. Nasby (decibel@rrs.decibel.org)
-- All rights reserved.
--
-- $Id: rrs.sql 53 2005-03-25 05:55:08Z decibel $

SET search_path = rrs, pg_catalog;

BEGIN;

CREATE OR REPLACE VIEW rrs.history_data_interval_run_time_v AS
    SELECT h.*
            , CASE WHEN run_time_sec > 0
                THEN rrs.seconds_to_interval(
                        rrs.interval_to_seconds(data_interval)
                        * desired_run_time_sec
                        / run_time_sec
                    )
                END AS next_data_interval
        FROM
            ( SELECT rrs.interval_to_seconds(
                                rrs.setting_get('desired run time')::interval
                        ) AS desired_run_time_sec
            ) AS s
            , ( SELECT start_time, end_time, data_interval
                        , end_time - start_time AS run_time
                        , rrs.interval_to_seconds( end_time - start_time ) AS run_time_sec
                    FROM history_data_interval ) h
;

CREATE TABLE version (
    component   text    NOT NULL CONSTRAINT version__component PRIMARY KEY
    , version     text    NOT NULL
) WITHOUT OIDs;
INSERT INTO version VALUES('schema','0.4');
INSERT INTO version VALUES('functions','0.4');

CREATE TABLE setting (
    setting_name    text    NOT NULL CONSTRAINT setting__name PRIMARY KEY
    , setting       text    NOT NULL
) WITHOUT OIDS;

CREATE TABLE history (
	start_time	timestamp with time zone CONSTRAINT history__start PRIMARY KEY
	, end_time	timestamp with time zone NOT NULL
) WITHOUT OIDs;

CREATE TABLE history_data_interval (
	data_interval	interval	NOT NULL
) INHERITS( history ) WITHOUT OIDs;

COMMIT;

-- vi: expandtab sw=4 ts=4
